import React from 'react';
import { FormControlProps, FormBaseControl } from './Item';
/**
 * Color 颜色选择框
 * 文档：https://baidu.gitee.io/amis/docs/components/form/color
 */
export interface ColorControlSchema extends FormBaseControl {
    /**
     * 指定为颜色选择框
     */
    type: 'color';
    /**
     * 是否显示清除按钮
     */
    clearable?: boolean;
    /**
     * 颜色格式
     */
    format?: 'hex' | 'rgb' | 'rgba' | 'hls';
    /**
     * 选中颜色后是否关闭弹出层。
     */
    closeOnSelect?: boolean;
    /**
     * 预设颜色，用户可以直接从预设中选。
     */
    presetColors?: Array<any>;
    /**
     * 是否允许用户输入颜色。
     */
    allowCustomColor?: boolean;
}
export interface ColorProps extends FormControlProps, Omit<ColorControlSchema, 'type'> {
}
export interface ColorControlState {
    open: boolean;
}
export default class ColorControl extends React.PureComponent<ColorProps, ColorControlState> {
    static defaultProps: Partial<ColorProps>;
    state: ColorControlState;
    render(): JSX.Element;
}
export declare class ColorControlRenderer extends ColorControl {
}
